<?php
ini_set('session.gc_maxlifetime',10);
ini_set('session.gc_probability ' ,1);
ini_set('session.gc_divisor',5 );
class FileSessionHandler
{
    private $savePath;

    function open($savePath, $sessionName)
    {
        $this->savePath = $savePath;
        if (!is_dir($this->savePath)) {
            mkdir($this->savePath, 0777);
        }
        echo __FUNCTION__."<BR>";
        return true;
    }

    function close()
    {
        echo __FUNCTION__."<BR>";
        return true;
    }

    function read($id)
    {
        echo __FUNCTION__."<BR>";
        return (string)@file_get_contents("$this->savePath/sess_$id");
    }

    function write($id, $data)
    {
        echo __FUNCTION__."<BR>";
        return file_put_contents("$this->savePath/sess_$id", $data) === false ? false : true;
    }

    function destroy($id)
    {
        $file = "$this->savePath/sess_$id";
        if (file_exists($file)) {
            unlink($file);
        }
        echo __FUNCTION__."<BR>";
        return true;
    }

    function gc($maxlifetime)
    {
        foreach (glob("$this->savePath/sess_*") as $file) {
            if (filemtime($file) + $maxlifetime < time() && file_exists($file)) {
                unlink($file);
            }
        }
        echo __FUNCTION__."<BR>";
        return true;
    }


    function end(){
        echo '我是最后脚本结束register_shutdown_function调用'."<br>";
    }
}

$handler = new FileSessionHandler();
session_set_save_handler(
    array($handler, 'open'),
    array($handler, 'close'),
    array($handler, 'read'),
    array($handler, 'write'),
    array($handler, 'destroy'),
    array($handler, 'gc')
);
// 下面这行代码可以防止使用对象作为会话保存管理器时可能引发的非预期行为
register_shutdown_function(array($handler,end));
session_start();
$_SESSION['name'] = 'lulublog';
// session_commit();
// session_write_close(); // 如果开启，那顺序就是open read  （gc） write close
// session_destroy();
// session_regenerate_id(true);